From 59036c2eb15cf5afe22afaa2c7626592b7629694 Mon Sep 17 00:00:00 2001
From: Adam Samalik <asamalik@redhat.com>
Date: Oct 02 2019 18:29:34 +0000
Subject: [PATCH 15/88] rewrite language building


---

diff --git a/build-scripts/Dockerfile b/build-scripts/Dockerfile
index 2f7cd80..0f41de8 100644
--- a/build-scripts/Dockerfile
+++ b/build-scripts/Dockerfile
@@ -1,13 +1,13 @@
 FROM fedora:29
 
 RUN dnf -y module install nodejs:10/default && \
-    dnf -y install git && \
+    dnf -y install git python3-yaml && \
     dnf clean all
 
 RUN npm i -g @antora/cli@2.0 @antora/site-generator-default@2.0
 
-ADD rebuild-site.sh /antora/rebuild-site.sh
+ADD build-translated.py /antora/build-translated.py
 
 WORKDIR /antora
 
-CMD /antora/rebuild-site.sh
+CMD /antora/build-translated.py
diff --git a/build-scripts/build-translated.py b/build-scripts/build-translated.py
new file mode 100755
index 0000000..fad81b0
--- /dev/null
+++ b/build-scripts/build-translated.py
@@ -0,0 +1,199 @@
+#!/usr/bin/python3
+
+import tempfile, yaml, os, errno, subprocess, copy, datetime, shutil, sys
+
+GLOBAL_CONFIG = {
+    "docs_repo_url": "https://pagure.io/fedora-docs/docs-fp-o.git",
+    "docs_repo_branch": "stg",
+    "translated_sources_repo_url": "https://pagure.io/fedora-docs/translated-sources.git"
+}
+
+
+def log(msg):
+    print(msg)
+
+
+def get_languages(config):
+    languages_dict = {}
+
+    with tempfile.TemporaryDirectory() as workdir:
+        translated_sources_repo = os.path.join(workdir, "translated_sources_repo")
+        subprocess.run(["git", "clone", config["translated_sources_repo_url"], translated_sources_repo])
+
+        languages = []
+        filename_blacklist = [".git"]
+        for filename in os.listdir(translated_sources_repo):
+            filepath = os.path.join(translated_sources_repo, filename)
+            if os.path.isdir(filepath) and filename not in filename_blacklist:
+                languages.append(filename)
+
+        languages.sort()
+
+        for lang in languages:
+            languages_dict[lang] = []
+
+            lang_dir = os.path.join(translated_sources_repo, lang)
+            for component in os.listdir(lang_dir):
+                version_dir = os.path.join(lang_dir, component)
+                for version in os.listdir(version_dir):
+                    start_path = "{lang}/{component}/{version}".format(
+                            lang=lang, component=component, version=version)
+
+                    # This is a workaround for cases when a component doesn't have
+                    # the ROOT module that should contain the antora.yml.
+                    # Without the ROOT module the translation scripts won't
+                    # pick up the antora.yml causing the docs build to fail.
+                    # So we're only including directories with the antora.yml file.
+                    if "antora.yml" in os.listdir(os.path.join(version_dir, version)):
+                        languages_dict[lang].append(start_path)
+
+    return languages_dict
+
+
+def generate_lang_switch_ui(languages):
+    template_start = """
+        <div class="page-languages">
+            <button class="languages-menu-toggle" title="Show other languages of the site">en-US</button>
+            <div class="languages-menu">
+    """
+    template_end = """
+            </div>
+        </div>
+    """
+
+    template_list = []
+    template_list.append(template_start)
+    for language in languages:
+        link = '<a class="language" href="{{{{siteRootPath}}}}/../{language}{{{{page.url}}}}">{language}</a>'.format(
+                    language=language)
+        template_list.append(link)
+    template_list.append(template_end)
+
+    return "\n".join(template_list)
+
+
+def main():
+    config = GLOBAL_CONFIG
+
+    log("")
+    log("===== Getting a list of languages =====")
+    languages = get_languages(config)
+    log("  Languages: {}".format(" ".join(languages)))
+
+
+    log("")
+    log("===== Generating the language switch UI =====")
+    lang_switch_ui = generate_lang_switch_ui(["en-US"] + list(languages.keys()))
+    
+
+    log("")
+    log("===== Getting the site definition =====")
+    with tempfile.TemporaryDirectory() as workdir:
+        docs_repo = os.path.join(workdir, "docs_repo")
+        subprocess.run(["git", "clone", "--branch", config["docs_repo_branch"], config["docs_repo_url"], docs_repo])
+
+        with open(os.path.join(docs_repo, "site.yml"), "r") as file:
+            original_site_yml = yaml.safe_load(file)
+
+
+        log("")
+        log("===== Creating the language switch UI files =====")
+        ui_dir = os.path.join(docs_repo, "supplemental-ui", "partials")
+        try:
+            os.makedirs(ui_dir)
+        except OSError as e:
+            if e.errno != errno.EEXIST:
+                raise
+
+        ui_file = os.path.join(ui_dir, "page-languages.hbs")
+        with open(ui_file, "w") as file:
+            file.write(lang_switch_ui)
+
+        log("")
+        log("===== Generating site.lang.yml files =====")
+        for lang, start_paths in languages.items():
+            lang_site_yml = copy.deepcopy(original_site_yml)
+
+            lang_site_yml["output"]["dir"] = "./public/{lang}".format(lang=lang)
+
+            lang_site_yml["content"] = {}
+            lang_site_yml["content"]["branches"] = "master"
+            lang_site_yml["content"]["sources"] = []
+
+            for start_path in start_paths:
+                source = {}
+                source["url"] = config["translated_sources_repo_url"]
+                source["start_path"] = start_path
+
+                lang_site_yml["content"]["sources"].append(source)
+
+            filename = os.path.join(docs_repo, "site-{lang}.yml".format(lang=lang))
+            with open(filename, "w") as file:
+                file.write(yaml.dump(lang_site_yml))
+
+            log("  {lang} done".format(lang=lang))
+
+
+        # Timestamp to be included in the footer of the docs
+        timestamp = datetime.datetime.now().strftime('%Y-%m-%d %H:%M:%S UTC')
+        antora_env = {"ANTORA_DATE": timestamp}
+
+        # First, building and copying the en-US site
+        log("")
+        log("===== Building the en-US site =====")
+        result = subprocess.run(["antora", "--html-url-extension-style=indexify", os.path.join(docs_repo, "site.yml")], env=antora_env)
+
+        if result.returncode != 0:
+            log("ERROR building the en-US site")
+            sys.exit(1)
+
+            
+        log("")
+        log("===== Copying the en-US site =====")
+        source_dir = os.path.join(docs_repo, "public")
+        target_dir_copying = "/antora/output/en-US.building"
+        target_dir_copied = "/antora/output/en-US.building/en-US"
+        target_dir_final = "/antora/output/en-US"
+        shutil.rmtree(target_dir_copying, ignore_errors=True)
+        subprocess.run(["cp", "-r", source_dir, target_dir_copying])
+        shutil.rmtree(target_dir_final, ignore_errors=True)
+        shutil.move(target_dir_copied, target_dir_final)
+        shutil.rmtree(target_dir_copying, ignore_errors=True)
+
+        log("")
+        log("===== Copying the index.html =====")
+        source_index_html = os.path.join(docs_repo, "static", "index.html")
+        target_index_html = "/antora/output/index.html"
+        shutil.copy(source_index_html, target_index_html)
+
+
+        # Second, building and copying all the translated sites
+        for lang in languages:
+            log("")
+            log("===== Building the {lang} site =====".format(lang=lang))
+            filename = "site-{lang}.yml".format(lang=lang)
+            result = subprocess.run(["antora", "--html-url-extension-style=indexify", os.path.join(docs_repo, filename)], env=antora_env)
+
+            if result.returncode != 0:
+                log("ERROR building the {lang} site".format(lang=lang))
+                sys.exit(1)
+
+
+        for lang in languages:
+            log("")
+            log("===== Copying the {lang} site =====".format(lang=lang))
+            source_dir = os.path.join(docs_repo, "public")
+            target_dir_copying = "/antora/output/{lang}.building".format(lang=lang)
+            target_dir_copied = "/antora/output/{lang}.building/{lang}".format(lang=lang)
+            target_dir_final = "/antora/output/{lang}".format(lang=lang)
+            shutil.rmtree(target_dir_copying, ignore_errors=True)
+            subprocess.run(["cp", "-r", source_dir, target_dir_copying])
+            shutil.rmtree(target_dir_final, ignore_errors=True)
+            shutil.move(target_dir_copied, target_dir_final)
+            shutil.rmtree(target_dir_copying, ignore_errors=True)
+    
+
+
+
+if __name__ == "__main__":
+    main()
diff --git a/supplemental-ui/partials/page-languages.hbs b/supplemental-ui/partials/page-languages.hbs
index b65342e..b5858f3 100644
--- a/supplemental-ui/partials/page-languages.hbs
+++ b/supplemental-ui/partials/page-languages.hbs
@@ -2,8 +2,5 @@
     <button class="languages-menu-toggle" title="Show other languages of the site">en-US</button>
     <div class="languages-menu">
         <a class="language" href="{{siteRootPath}}/../en-US{{page.url}}"">en-US</a>
-        <a class="language" href="{{siteRootPath}}/../cs{{page.url}}">cs</a>
-        <a class="language" href="{{siteRootPath}}/../fr{{page.url}}">fr</a>
-        <a class="language" href="{{siteRootPath}}/../jp{{page.url}}">jp</a>
     </div>
 </div>

